#include "tpager.h"
char *client_atom_name[] = {
	"_NET_WM_NAME",
	"_NET_WM_VISIBLE_NAME",
	"_NET_WM_ICON_NAME",
	"_NET_WM_VISIBLE_ICON_NAME",
	"_NET_WM_DESKTOP",
	"_NET_WM_WINDOW_TYPE",
	"_NET_WM_WINDOW_TYPE_DESKTOP",
	"_NET_WM_WINDOW_TYPE_DOCK",
	"_NET_WM_WINDOW_TYPE_TOOLBAR",
	"_NET_WM_WINDOW_TYPE_MENU", //9
	"_NET_WM_WINDOW_TYPE_UTILITY",
	"_NET_WM_WINDOW_TYPE_SPLASH",
	"_NET_WM_WINDOW_TYPE_DIALOG",
	"_NET_WM_WINDOW_TYPE_NORMAL",
	"_NET_WM_STATE",
	"_NET_WM_STATE_MODAL",
	"_NET_WM_STATE_STICKY",
	"_NET_WM_STATE_MAXIMIZED_VERT",
	"_NET_WM_STATE_MAXIMIZED_HORZ",
	"_NET_WM_STATE_SHADED", //19
	"_NET_WM_STATE_SKIP_TASKBAR",
	"_NET_WM_STATE_SKIP_PAGER",
	"_NET_WM_STATE_HIDDEN",
	"_NET_WM_STATE_FULLSCREEN",
	"_NET_WM_STATE_ABOVE",
	"_NET_WM_STATE_BELOW",
	"_NET_WM_ALLOWED_ACTIONS",
	"_NET_WM_ACTION_MOVE",
	"_NET_WM_ACTION_RESIZE",
	"_NET_WM_ACTION_MINIMIZE", //29
	"_NET_WM_ACTION_SHADE",
	"_NET_WM_ACTION_STICK",
	"_NET_WM_ACTION_MAXIMIZE_HORZ",
	"_NET_WM_ACTION_MAXIMIZE_VERT",
	"_NET_WM_ACTION_FULLSCREEN",
	"_NET_WM_ACTION_CHANGE_DESKTOP",
	"_NET_WM_ACTION_CLOSE",
	"_NET_WM_STRUT",
	"_NET_WM_ICON_GEOMETRY",
	"_NET_WM_ICON", //39
	"_NET_WM_PID",
	"_NET_WM_HANDLED_ICONS",
	"UTF8_STRING",
	"WM_STATE" //43
};

#define CLIENT_ATOM_COUNT 44
Atom client_atom[CLIENT_ATOM_COUNT];

#define NAME client_atom[0]
#define VISIBLE_NAME client_atom[1]
#define ICON_NAME client_atom[2]
#define VISIBLE_ICON_NAME client_atom[3]
#define DESKTOP client_atom[4]
#define WINDOW_TYPE client_atom[5]
#define WINDOW_TYPE_DESKTOP client_atom[6]
#define WINDOW_TYPE_DOCK client_atom[7]
#define WINDOW_TYPE_TOOLBAR client_atom[8]
#define WINDOW_TYPE_MENU client_atom[9]
#define WINDOW_TYPE_UTILITY client_atom[10]
#define WINDOW_TYPE_SPLASH client_atom[11]
#define WINDOW_TYPE_DIALOG client_atom[12]
#define WINDOW_TYPE_NORMAL client_atom[13]
#define STATE client_atom[14]
#define STATE_MODAL client_atom[15]
#define STATE_STICKY client_atom[16]
#define STATE_MAXIMIZED_VERT client_atom[17]
#define STATE_MAXIMIZED_HORZ client_atom[18]
#define STATE_SHADED client_atom[19]
#define STATE_SKIP_TASKBAR client_atom[20]
#define STATE_SKIP_PAGER client_atom[21]
#define STATE_HIDDEN client_atom[22]
#define STATE_FULLSCREEN client_atom[23]
#define STATE_ABOVE client_atom[24]
#define STATE_BELOW client_atom[25]
#define UTF8_STRING client_atom[42]
#define WM_STATE client_atom[43]
int get_props(Display *disp, Window w, Atom prop, unsigned char **data, int *count) {
	Atom type_ret;
	int format_ret;
	unsigned long unused;
	return XGetWindowProperty(disp, w, prop,
			       0L, 1024L, False, AnyPropertyType, &type_ret,
			       &format_ret, (unsigned long*)count, &unused, data);
}

void client_props_init(Display* display) {
	XInternAtoms (display, client_atom_name, CLIENT_ATOM_COUNT, True, client_atom);
}

int get_prop_cardinal(Display *disp, Window win, Atom prop) {
	int ret = -1;
	Atom ar; 
	int fr;
	unsigned long ni,ba;
	unsigned char *data;
	XGetWindowProperty (disp, win, prop, 0, 1L, False, XA_CARDINAL, &ar, &fr, &ni, &ba, &data);
	if (data) {
		ret = ((int *)data)[0];
		XFree(data);
	}
	return ret;
}

void set_type (Display *disp, Window win, Atom* type_list, int num) {
	XChangeProperty(disp, win, WINDOW_TYPE, XA_ATOM, 32, PropModeReplace, (unsigned char *)type_list, num);
}

void set_state (Display *disp, Window win, Atom* state_list, int num) {
	XChangeProperty(disp, win, WINDOW_TYPE, XA_ATOM, 32, PropModeReplace, (unsigned char *)state_list, num);
}

void set_panel_state (Display *disp, Window win) {
	Atom state[] = {STATE_STICKY, STATE_SKIP_TASKBAR, STATE_SKIP_PAGER, STATE_ABOVE};
	set_state(disp, win,(Atom*) &state, 4);
}

void set_panel_type (Display *disp, Window win) {
	Atom type[] = {WINDOW_TYPE_TOOLBAR};
	set_type (disp, win,(Atom *) &type, 1);
}

void set_workspc (Display *disp, Window win, int workspc) {
	XChangeProperty (disp, win, DESKTOP, XA_CARDINAL, 32, PropModeReplace, (unsigned char *)&workspc, 1);
}

